! 2018_04_05 Author: Joaquim Perez-Losada
! SFE + mutation loss

program PLOS_One_Response
USE MSFLIB
	
implicit none

integer::i,j,y,xy,kk,ii,ijk,jj,jjp   ! service variabales
character(2) dita
integer*4    zero_count
integer::    ncont,acont,ncont2,bcount,num_set 
integer::    mra,mrap
real*4 x,z
real*4 resultat,resultat2,resultat3

integer:: ny,ni                 ! Grid (row,column) dimensions
real*4    r,sum,z_limit,x_limit ! grid parameters
integer:: code                  ! position of the initial node at the center of the grid. If grid (1000,1000) code = 500

integer:: mut_ratio             ! Mutation Ratio (ie, phonemic time loss in generations/phoneme)
integer:: mutation_Switch       ! Mutation switch. Set = 0 no mutation (ie mutation ratio does not appy) 
real*4    rr                    ! net growth ratio (fecundity)
integer:: rep 
real*4    pe                    ! persistence
integer:: persistence 
real*4    dis                   ! jump distance (km)
integer:: jump 
integer:: dem_thres             ! demographic threshold

integer:: ntotal,nmax,smax      ! Max number of languages
integer:: ng                    ! number of phonemes. In our FORTRAN compiles, max value = 95  
integer:: min_pho, max_pho      ! Min and max number of phonemes within a node for simulation

integer:: output_time   ! Time (in generations) ouput results
integer:: t             ! Time (in generations) 

parameter (nmax=10, ng=95, rr=0.2d0, ntotal=10, smax = 10, mut_ratio = 60, mutation_Switch = 1)    
 
parameter (ny = 1000, ni = 1000, code = 500)      ! Set grid dimensions ny,ni
parameter (t  = 10, output_time = 10)             ! t= time of simulations (gen); output_time = time for ouput results (gen).
parameter (pe = 0.38d0, dis = 50, dem_thres = 10) ! Set persistence (pe), dispersal distance(dis) and demographic threshold (dem_thres) 

real,dimension (smax)::rand_cont
integer copy_in(smax),copy_from(smax),ara(smax),para(smax)

character(ng+1), dimension (ni,ny,smax):: a,b 
character(1)   , dimension(ntotal):: id
character(ng+1)  xstring  
character(20)    name_start(ntotal),name_world(ntotal)
real*8  ax(smax,ng) 
real*4  aa(ntotal,ng)
real*4  cont_po(ng),cont_pho(smax)

integer:: phone_world                                   ! Variables for tF calculations
parameter (phone_world = 908)                           ! Total number of phonemes in Database S1
real*8    az(smax,phone_world), cont_po_z(phone_world) 
real*4    cont_po_w(phone_world),aw(smax,phone_world)   
real*4    tf_z, tf_world, sum_po                        ! tf variables

!
!**************************** Initialize variables *****************************************************************************
!
    call SEED(RND$TIMESEED)

    dita ='5'      
    a = ' '
    b = ' '
    xstring ='1111111'
    name_start = ' '

    aa  = 0.0d0     
    ax  = 0.0d0
    
    call RANDOM(resultat2)                                
    resultat   = min(int(int(resultat2*mra) + 1.0d0),mra)
!
! OPEN and READ input files. Select input file below *************************************************
!
    
!    open(20,file='UPSID_10_lang_77_d_50_Single_Lang_Puk_77.txt',status='unknown') 
    open(20,file='UPSID_10_lang_40_77_phone_Seg_Had_62_Sdw_54.txt',status='unknown')
!   open(20,file='UPSID_10_lang_40_77_phone_Seg_Ewe_40_Puk_77.txt',status='unknown')

    
    do ijk = 1,ntotal
        read(20,30)name_world(ijk),(aw(ijk,ii),ii=1,phone_world)      ! Read complete sequence of 1 and 0 from input file 
    30  format(A1,908F2.0)                                             
        write(*,*) name_world(ijk)
              jj = 1 
        do ii = 1,phone_world          
            if(aw(ijk,ii).eq.1) then
               ax(ijk,jj)=1
               jj = jj + 1
            endif
        enddo ! ii   
           id(ijk)= name_world(ijk)
           name_start(ijk) = name_world(ijk)
    enddo  ! ijk
    close(20)
    
!
!************** Initial Tf ***********************************************
!
    
sum_po  = 0d0
cont_po = 0.0d0

do ii = 1,phone_world
 do kk = 1,ntotal
    if(aw(kk,ii).eq.1.0) cont_po_w(ii) = cont_po_w(ii) + 1
 enddo
    sum_po = sum_po + cont_po_w(ii)             ! Total number of cases
enddo

do ii = 1,phone_world
    cont_po_w(ii) = (cont_po_w(ii)/sum_po)**2   ! Relative frequencies
enddo
sum_po = 0.0d0

do ii = 1,phone_world
    sum_po = sum_po + cont_po_w(ii)
enddo

tf_world = (1.0d0/sum_po)-1.0d0                 ! Tf as defined in Newman, F.(1995)

!
!****** Max and Min number of phonemes  ********************************************************************************
!

min_pho =  1E6
max_pho = -1E6
sum_po = 0d0
cont_pho = 0

do kk = 1,smax
 do ii = 1,ng
    if(ax(kk,ii).eq.1.0) cont_pho(kk) = cont_pho(kk) + 1
 enddo
 if((cont_pho(kk).gt.0).and.(cont_pho(kk).lt.min_pho)) min_pho = cont_pho(kk)  ! Minimum number of phonemes present in all languages in the node
 if((cont_pho(kk).gt.0).and.(cont_pho(kk).gt.max_pho)) max_pho = cont_pho(kk)  ! Maximum number of phonemes present in all languages in the node
enddo

!
!***** Populate initial settlements. (Data printed in file start.txt) *********************************************************
!

    open(17,file='start.txt',status='unknown',access='append')

    write(17,'(1x,t5,a,i6)')        'Max number lang             = ',nmax
    write(17,'(1x,t5,a,i6)')        'Mutation ratio              = ',mut_ratio 
    write(17,'(1x,t5,a,i6)')        'Mutation Switch             = ',mutation_Switch
    write(17,'(1x,t5,a,f6.2)')      'Growth ratio                = ',rr
    write(17,'(1x,t5,a,i6)')        'Generations                 = ',t
    write(17,'(1x,t5,a,i6)')        'String Ng                   = ',ng
    write(17,'(1x,t5,a,f6.2)')      'Distance (km)               = ',dis
    write(17,'(1x,t5,a,i6)')        'Demographic threshold       = ',dem_thres
    write(17,'(1x,t5,a,f6.2)')      'Persistence                 = ',pe
    write(17,'(1x,t5,a,f6.2)')      'Tf initial                  = ',tf_world
    write(17,'(1x,t5,a,i6,i6)')     'Min and max num of phoenmes = ',min_pho,max_pho
    write(17,'(1x,t5,a,i6,i6)')     'Starting node               = ',code,code

    do kk =1,smax
        do j = 1,ng
            Write( dita, '(f2.0)' )  ax(kk,j)
            xstring(j:j) = dita
        enddo
        
        xstring(ng+1:ng+1) = id(kk)
        a(code,code,kk) = xstring
        write(17,709) kk, name_start(kk),a(code,code,kk)
709     format(i3,x,A10,x,A100)                                
    enddo
    
    close(17)

    ax = 0.0d0                                              ! Clear service matrix. Used for Tf calculations below
  
!
!==============Time Integration====================================================
!
    do j=1,t
!
!============== Dispersion ===================================================================
! 
    do y=1,ny
    do i=1,ni

	    ncont       = 0   
	    acont       = 0
	    rand_cont   = 0
	    persistence = 0
	    jump        = 0
        bcount      = 0
    
	    mra  = 0
	    para = 0
	    ara  = 0
	    rand_cont = 0
	
	    do kk = 1,smax
            if(len_trim(a(i,y,kk)).ne.0.0) acont = acont + 1
 	    enddo !kk

        if (acont.eq.0) goto 100                             
    
    jj = 1
	do ii =1,smax
    if(len_trim(a(i,y,ii)).ne.0.0) then
        para(jj)  = ii
        jj        = jj + 1
    endif
    enddo
     
    mra = jj -1
    
23457 	 jump     = 4*nint((1-pe)*acont/4.0)
        
     if(jump.eq.smax) then
        write(*,*) 'problems with jump', i,y,jump
        pause
     endif
     persistence = acont - jump
     jump        = jump/4
		
    if (persistence.lt.0) then                             
        write(*,*) ' problems with persistence ', persistence
        pause
    endif		

do ii = 1,persistence
371   call RANDOM(resultat2)                               
      resultat   = min(int(int(resultat2*mra) + 1.0d0),mra) 

    if(rand_cont(resultat).eq.0) then
      ara(ii)    = para(resultat)
      rand_cont(resultat) = 1
    else
      goto 371  
    endif
enddo ! ii

do kk = 1,4
do ii = persistence + jump*(kk-1) + 1, persistence + jump*(kk)
361   call RANDOM(resultat2)                                 
      resultat   = min(int(int(resultat2*mra) + 1.0d0),mra) 

    if(rand_cont(resultat).eq.0) then
      ara(ii)    = para(resultat)
      rand_cont(resultat) = 1
    else
      goto 361  
    endif
enddo ! ii
enddo ! kk

 bcount = 1
	do z=-50/50,50/50
	do x=-50/50,50/50

 	 r=dis*sqrt(x**2+z**2)

		if (r==0) then
		    if(persistence.eq.0) goto 80  
			
	 	    kk =1						    
			do jj = 1,persistence			           
171             if(len_trim(b(i+x,y+z,kk)).eq.0) then
                   b(i+x,y+z,kk)       = a(i,y,ara(jj))
                   kk = kk + 1
                else 
                   kk = kk + 1
                if(kk.gt.smax) then   
			       call RANDOM(resultat2)                                           
                   resultat            = min(int(int(resultat2*smax) + 1.0d0),smax) 
                   b(i+x,y+z,resultat) = a(i,y,ara(jj))
                   bcount = bcount + 1
                else   
                   goto 171
                endif
                endif
            enddo !jj
            goto 80    
		endif
		
				
		if (x==0.or.z==0) then
            if(jump.eq.0) goto 80  
	 	    kk =1						    
			do jj = 1,jump
			  
			     z_limit = z
                 x_limit = x
                 
			     if(y==1.and.z==-1)  z_limit = 0
                 if(y==ny.and.z==+1) z_limit = 0
                 
                 if(i==1.and.x==-1)  x_limit = 0
                 if(i==ni.and.x==+1) x_limit = 0             
			
			
			 172 if(kk.gt.smax) then
			     call RANDOM(resultat2)                                            
                 resultat            = min(int(int(resultat2*smax) + 1.0d0),smax) 
                 
                 b(i+x_limit,y+z_limit,resultat) = a(i,y,ara(persistence + bcount))
                 bcount = bcount + 1
             else    
			 if(len_trim(b(i+x_limit,y+z_limit,kk)).eq.0) then
           
                   b(i+x_limit,y+z_limit,kk) = a(i,y,ara(persistence + bcount))
                   kk     = kk + 1
                   bcount = bcount + 1
             else
                   kk = kk + 1    
			       goto 172
             endif
             endif
               
            enddo !jj
            goto 80
        endif    
                
    	80 continue
	    		
		end do
		end do
		    		
100	continue
    end do
    end do	
    

a = b   ! Update matrix a(t) = b(t+1)
	           
b = ' ' ! Initialize matrix for next generation

!
!=============REACTION ==================================================================
! 
	do y=1,ny
	do i=1,ni
	
	    acont = 0
	    rep   = 0

		do kk = 1,smax
		    if(len_trim(a(i,y,kk)).ne.0.0) acont = acont + 1
		enddo !kk

	    if (acont.eq.0) goto 180        

20 rep = nint(acont*rr)                 
   if(rep.lt.1) rep = 1
    
 if((rep+acont).ge.smax) then
   rep   = smax - acont
 endif
   
812 continue
   
 if(rep.lt.0) then
   write(*,*) 'Negative Reproduction: error'
   pause
 endif
   
rand_cont = 0 ! Zeroth counter. Needed to avoid sons beeing copied on the same iteration

!   
! Vertical transmission. Parents are kept alive. Rep is the number of new individuals
!    	    
jj        = 1
jjp       = 1
mra       = 0
copy_from = 0

do ii =1,smax
    if(len_trim(a(i,y,ii)).ne.0.0) then
        ara(jj)  = ii
        jj       = jj  + 1
    endif
enddo

do ii =1,smax
    if(len_trim(a(i,y,ii)).eq.0.0) then
        para(jjp) = ii
        jjp       = jjp + 1
    endif
enddo

    mra  = jj  - 1
    mrap = jjp - 1

do kk = 1,rep
    call RANDOM(resultat)                                     
    copy_from(kk)   = min(int(int(resultat*mra)+1.0d0),mra)   
    a(i,y,para(kk)) = a(i,y,ara(copy_from(kk)))
enddo

180 continue

end do   ! i
end do   ! y 

!
!======== Mutation ================
!

if(mutation_Switch.eq.0) goto 292                          ! No mutation if mutation_Switch = 0

if(mod(j,mut_ratio).eq.0) then                             ! Mutation clock. When time is multiple of mut_ratio, then mutation starts.  
    write(*,*) "Mutation at generation ",j
    do y=1,ny
    do x=1,ni
        ncont   = 0
        ax      = 0.0d0
        cont_po = 0.0d0
        num_set = 0  
        xstring = '  '
    
    do kk =1,smax
        if (len_trim(a(x,y,kk)).eq.0) goto 1398
        xstring = a(x,y,kk)
        num_set = num_set + 1
1398 continue
    enddo         ! kk
   
   if(num_set.eq.0) goto 1397                             
    
   if(num_set.lt.dem_thres) then                           ! Mutation condition if number of tribes in the cell < Demographic threshold

do jj = 1,smax                                             ! All languages in each node MUTATE
     if (len_trim(a(x,y,jj)).eq.0) goto 2398               ! Skip empty positions. Each node can accomodate up to smax languages. 

      xstring = a(x,y,jj) 
      zero_count = 0        

     do kk = 1,ng
        read( xstring(kk:kk), '(f2.0)' ) ax(2,kk)
        if(ax(2,kk).eq.1) then 
            zero_count = zero_count + 1
            ax(3,zero_count) = kk
            
        endif
     enddo ! kk
     
    if(zero_count.eq.0) goto 2398                            
 
2312 call RANDOM(resultat2)
     resultat3 = min(int(int(resultat2*zero_count)+1.0d0),zero_count)
     
     ax(2,ax(3,resultat3)) = 0
   
    do kk = 1,ng
        Write( dita, '(f2.0)' )  ax(2,kk)
        xstring(kk:kk) = dita        
    enddo
    
    a(x,y,jj) = xstring

2398 enddo
     endif         
1397 continue
enddo  ! x
enddo  ! y

endif

!
!===== Binary de-codification for OUTPUT file ========================================================
!
292 continue
    
if(j.eq.output_time) then                                                ! Check adequate ouput_time
               
    open (40, file= 'simulac1.txt',status='unknown')
    open (120,file= 'tfdelta1.txt',status='unknown')
    write(40,*) "  Gen    Y(km)  Npho Lang  Tf_ini Tf_mut  minpho  maxpho"
           
do y=code,ny    ! Normal loop for each node tf calculation
     
    ncont   = 0
    ax      = 0.0d0
    cont_po = 0.0d0
    num_set = 0
        
    do kk =1,smax
        xstring = a(code,y,kk)                      
        if (len_trim(a(code,y,kk)).eq.0) goto 5239  
        num_set = num_set + 1
            do ii = 1,ng
                read( xstring(ii:ii), '(f2.0)' ) ax(kk,ii)
                if(ax(kk,ii).eq.1.0) ncont  = ncont  + 1
            enddo ! ii           
5239 continue
    enddo         ! kk
  
    if (ncont.eq.0) goto  5417    ! skip empty nodes
    
!
!****** Counts max and min number of phonemes *************************************************************************
!
    min_pho  =  1E6
    max_pho  = -1E6
    sum_po   = 0d0
    cont_po  = 0.0d0
    cont_pho = 0.0d0
    
    do kk = 1,smax
        do ii = 1,ng
            if(ax(kk,ii).eq.1.0) cont_pho(kk) = cont_pho(kk) + 1
        enddo
        if((cont_pho(kk).gt.0).and.(cont_pho(kk).lt.min_pho)) min_pho = cont_pho(kk)  ! Minimum number of phonemes present in all languages of the node
        if((cont_pho(kk).gt.0).and.(cont_pho(kk).gt.max_pho)) max_pho = cont_pho(kk)  ! Maximum number of phonemes among all languages present of the node
    enddo
            
!
! ******** Transform simulated language into real world phonemic frequencies *************************
!    

    az = 0.0d0
    do kk =1,smax
        jj = 1
908     if(name_world(jj).ne.id(kk)) then       ! ID the real language from which frequencies would be checked
            jj = jj + 1
            goto 908
        endif
        ijk = 1

        do ii = 1,ng
906         if(aw(jj,ijk).eq.1) then            ! From sequence of 1 and 0, build the real phonemic sequence
                az(kk,ijk)=ax(kk,ii)
                if(ijk.eq.phone_world) goto 904 
                ijk = ijk + 1
            else
                if(ijk.eq.phone_world) goto 904 
                ijk = ijk + 1
                goto 906
            endif
        enddo !ii
904     continue        
    enddo !kk

!
!********* Total Tf for the real world languages **************************
!
    sum_po  = 0d0
    cont_po_z = 0.0d0

    do ii = 1,phone_world
        do kk = 1,smax
            if(az(kk,ii).eq.1.0) cont_po_z(ii) = cont_po_z(ii) + 1
        enddo
        sum_po = sum_po + cont_po_z(ii)            ! Total number of cases
    enddo

    do ii = 1,phone_world
        cont_po_z(ii) = (cont_po_z(ii)/sum_po)**2  ! Relative frequencies
    enddo
    sum_po = 0.0d0

    do ii = 1,phone_world
        sum_po = sum_po + cont_po_z(ii)
    enddo

    tf_z = (1.0d0/sum_po)-1.0d0                    ! Tf as defined in Newman, F.(1995)
    
!
! ********** Output file *****************************
!
    do kk = 1,smax
     do ii = 1,ng
        if(ax(kk,ii).eq.1.0) cont_po(kk) = cont_po(kk) + 1   
     enddo  ! ii
    enddo   ! kk
    
    do kk = 1,smax
        write (120,'(908(i2,x),A1,x,i7)') (int(az(kk,ii)),ii=1,phone_world), id(kk), int(dis*(y-code))
    enddo !kk    
    
    write (40,44) j,int(dis*(y-code)),int(cont_po(1)),num_set, tf_world, tf_z, min_pho, max_pho 
    
44  format(i6,x,i7,x,i4,x,i4,3x,f6.2,x,f6.2,x,i6,x,i6)  
    
5417 continue
    enddo    ! y

close(40)
close(50)
 
endif      ! if time = last
    
print *,j  ! Print generation number on screen:
   
end do     ! time (j)

end program
    
